#!/bin/sh
source /etc/profile

this_sh=$0
exec_cmd="$*"
doFork=0

function split_exec_cmd() {
	local cnt=0
	exec_opt=""
	for i in $*; do
		if [ $cnt -eq 0 ]; then 
			exec_name=$(echo $i )
			cnt=1
		else
			exec_opt="$exec_opt $i"
		fi
	done
}

function run_exec_cmd() {
	local is_daemon=$1
	local app_name=$2
	local args=$3
	if [ "$app_name" != "$this_sh" ]; then ## Prevent self executing
		if [ -x $app_name ]; then 
			if [ "$is_daemon" != "0" ]; then
				$app_name $args &
			else
				$app_name $args &
			fi
		else
			ls $app_name
		fi
	fi
}

# Parse commands
for i in $exec_cmd; do
	if [ "$(echo $i|grep -o "&")" == "&" ]; then 
		doFork=1;
		exec_cmd="`echo $exec_cmd | sed -e 's/&//g' | sed -e 's/"//g'`"
	fi
	if [ "$(echo $i|grep -o "\-\-fork")" == "--fork" ]; then
		doFork=1;
		exec_cmd="`echo $exec_cmd | sed -e 's/--fork//g' | sed -e 's/"//g'`"
	fi
done

split_exec_cmd $exec_cmd

run_exec_cmd $doFork $exec_name $exec_opt

exit 0
