<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
	<style type="text/css">
        html, body { height: 100%; }
        html { display: table; margin: auto; }
        body { display: table-cell; vertical-align: middle; }
        #MotionOverlay { position: absolute; color: #ffff00; text-align: center; font-size: 15px; font-weight: bold; width: 20px; z-index: 100; }
        #InstantRecOverlay { position: absolute; color: #ff0000; text-align: center; font-size: 15px; font-weight: bold; width: 90px; z-index: 200; }
        #id_image { z-index: 1;}
	</style>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
    <video id="id_image" muted="muted" loop="loop" src="" type="video/mp4" autoplay></video>
    <div id="MotionOverlay" style='visibility:hidden;'>M</div>
    <div id="InstantRecOverlay" style='visibility:hidden;'>WEBM REC</div>
    <iframe src="" name=SetCgi frameborder="0" width="0" height="0" marginwidth="0" marginheight="0" scrolling="no"></iframe>
<script src="/js/jquery-3.6.0.min.js" type="text/javascript"></script>
<script src="/js/websocket/event.js" type="text/javascript"></script>
<script src="/js/websocket/jpegusr.js" type="text/javascript"></script>
<script src="/js/websocket/remuxer.js" type="text/javascript"></script>
<script src="/js/websocket/mp4.js" type="text/javascript"></script>
<script src="/js/websocket/videoconverter.js" type="text/javascript"></script>
<script language="javascript" type="text/javascript">
    var IP = document.location.hostname;
    var PORT = document.location.port;
    const listener = Symbol("event_listener");
    const listeners = Symbol("event_listeners"); 
    var ClientEventSource;
    var WebsockQueues={}; WebsockQueues[1]=[]; //video h.264
    var mimeType;
    var wsUri;
    var WebsockStatus = 0;
    var FirstWebsockFlag = 1;
    var IframeFlag = false;
    if (document.location.protocol == 'https:')
    {
        wsUri = "wss://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001";
    }
    else
    {
        wsUri = "ws://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001";
    }

    const element = document.getElementById('id_image');
    var Converter;
    <% FwFrameRateGet("FwModId","PortId"); %>
    var WebSockVideoStreamFps = STREAM_FRAMERATE;
    var FlushHandler;
    var FlushInverval = Math.floor(1000 / WebSockVideoStreamFps);
    var client_eventSource = new EventEmitter();
    var RawImage;

    window.addEventListener("load", Init, false);
    window.addEventListener("visibilitychange", function() {
        if (document.visibilityState == 'visible')
        {
            window.location.reload();
        }
        else if (document.visibilityState == 'hidden')
        {
            clearInterval(FlushHandler);
        }
        else
        {
            clearInterval(FlushHandler);
        }
    });

    function Flush() {
        for (let qidx in WebsockQueues) 
        {
            let RawImageQueue = WebsockQueues[qidx];
            while (RawImageQueue.length) 
            {
                RawImage = RawImageQueue.shift();
                if (RawImage)
                {
                    //console.log("Converter.appendRawData");
                    Converter.appendRawData(RawImage);
                }          
            }
        }
    }

    function StartStreamFlush() {
        FlushHandler = setInterval(()=>{
            client_eventSource.dispatchEvent('Flush');
        }, FlushInverval);
    }

    function Init() {
        websocket = new WebSocket(wsUri,["wjes"]);
        websocket.onopen = function(evt) { onOpen(evt) };
        websocket.onclose = function(evt) { onClose(evt) };
        websocket.onmessage = function(evt) { onMessage(evt) };
        websocket.onerror = function(evt) { onError(evt) };

        ClientEventSource = new EventSourceWrapper(client_eventSource);
        ClientEventSource.on('Flush', Flush.bind(this));
        StartStreamFlush();

        setTimeout(function() {
            parent.ViewerResize();
        }, 200);
    }

    function onOpen(evt) {
        doSend("GET /cgi-bin/fwstream.cgi?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001 HTTP/1.1\r\nHost: " + IP + "\r\nConnection: keep-alive\r\nUpgrade-Insecure-Requests: 1\r\nUser-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.90 Safari/537.36\r\nAccept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9\r\nAccept-Encoding: gzip, deflate\r\nAccept-Language: ko-KR,ko;q=0.9,en-US;q=0.8,en;q=0.7\r\n\r\n");
    }

    function onClose(evt) {

    }

    function onMessage(evt)
    {
        switch(WebsockStatus)
        {
            case -1:
                break;
            case 0:
                onAuthMessage(evt);
                break;
            case 1:
                onJesMessage(evt);
                break;
        }
    }

    function onAuthMessage(evt)
    {
        var AuthJsonResponse = evt.data;
        try {
            var AuthJsonParse = JSON.parse(AuthJsonResponse);
            //console.log("response_code : " + AuthJsonParse.response_code);
            //console.log("auth : " + AuthJsonParse.auth);
            //console.log("realm : " + AuthJsonParse.realm);
            //console.log("nonce : " + AuthJsonParse.nonce);
            document.all.SetCgi.src = "/web/cgi-bin/app/ws_auth.cgi?ResponseCode=" + AuthJsonParse.response_code + "&Auth=" + AuthJsonParse.auth + "&Realm=" + AuthJsonParse.realm + "&Nonce=" + AuthJsonParse.nonce +  "&FwCgiVer=0x0001";
            WebsockStatus = 1;
        } catch {
            WebsockStatus = -1;
        } finally {
            switch(WebsockStatus)
            {
                case -1:
                    alert("Websocket authentication failed, Please reconnect again.");
                    break;
                default:
                    break;
            }
        }
    }

    function onJesMessage(evt)
    {
        var arrayBufferView = new Uint8Array( evt.data );

        let jes_data = new jpeg_usr_t(arrayBufferView);

        if(jes_data.isKeyframe()) IframeFlag = true;

        if ( FirstWebsockFlag == 1 )
        {
            if (jes_data.codec_type == "H.265")
            {
                WebsockStatus = -1;
                alert("H.265 is not surported, Please change another Encoding.");
            }

            if (jes_data.codec_type == "H.264")
            {
                if( jes_data.isKeyframe() )
                {
                    //console.log("isKeyframe !!");
                    mimeType = "video/mp4; codecs=" + jes_data.codec;
                    Converter = new VideoConverter(element, WebSockVideoStreamFps, 1);
                    FirstWebsockFlag = 0;
                }
            }

            if (jes_data.codec_type == "MJPEG")
            {
                $("video").replaceWith("<img id='id_image' src=''></img>");
                FirstWebsockFlag = 0;
            }
        }

        if (jes_data.codec_type == "H.264")
        {
            if(IframeFlag)
            {
                if (document.visibilityState == 'visible')
                    WebsockQueues[1].push(jes_data);
            }
        }
        else if (jes_data.codec_type == "MJPEG")
        {
            $("video").replaceWith("<img id='id_image' src=''></img>");
            var reader<% FwGetParmValue("PortId"); %> = new FileReader();
            reader<% FwGetParmValue("PortId"); %>.onload = function (evt) {
                if (evt.target.readyState == FileReader.DONE) {
                    var url = evt.target.result;
                    document.getElementById("id_image").src = url;
                }
            }

            var arrayBufferView = new Uint8Array(evt.data);
            var blob = new Blob([arrayBufferView], { type: "image/jpeg" });
            reader<% FwGetParmValue("PortId"); %>.readAsDataURL(blob);
            blob = null;
            arrayBufferView = null;
            reader<% FwGetParmValue("PortId"); %> = null;
        }

        if( jes_data.motion != 0 )
        {
            var Viewer = document.getElementById('id_image');
            
            $("#MotionOverlay").css({
                "visibility" : "visible",
                "top" : Viewer.getBoundingClientRect().top,
                "left" : Viewer.getBoundingClientRect().left + Viewer.clientWidth - 22
            });
        }
        else
        {
            $("#MotionOverlay").css({
                "visibility" : "hidden",
                "top" : "0",
                "left" : "0",
            });
        }

        if( $('#LocalRecEnable', parent.document).val() != 0 )
        {
            var Viewer = document.getElementById('id_image');
            
            if (parent.SCREEN_SIZE == "origin")
            {
                $("#InstantRecOverlay").css({
                    "visibility" : "visible",
                    "top" : Viewer.getBoundingClientRect().top + 15,
                    "left" : Viewer.getBoundingClientRect().left + Viewer.clientWidth - 92
                });
            }
            else
            {
                $("#InstantRecOverlay").css({
                    "visibility" : "visible",
                    "top" : Viewer.getBoundingClientRect().top + 15,
                    "left" : Viewer.getBoundingClientRect().left + Viewer.clientWidth - 92
                }); 
            }
        }
        else
        {
            $("#InstantRecOverlay").css({
                "visibility" : "hidden",
                "top" : "0",
                "left" : "0",
            });
        }

        jes_data = null;
    }

    function onError(evt)
    {

    }

    function doSend(message)
    {
        var bytearray = new Uint8Array( message.length );
        
        websocket.binaryType = 'arraybuffer';
        for ( var idx = 0; idx < message.length; ++idx )
        {
            bytearray[idx] = message[idx].charCodeAt(0);
        }
        websocket.send(bytearray.buffer);
    }
</script>
</html>
